<template>
  <div class='app_button'>
  <button class='btn btn-outline-primary' @click="toggleModal">Edit</button>
    <modal :modal-id="modalId">
      <h4 style='margin-bottom: 0px; margin-top: 0px;'>
        Update meal
      </h4> 
      <label>Meal name:</label>
      <input id='meal_name' class='form-control' v-model='name'></input>
      <label>Price:</label>
      <input id='meal_price' class='form-control' v-model='price'></input>
      <button class='btn btn-outline-secondary' @click="toggleModal"> Back </button>
      <button class="btn btn-outline-info" @click="updateOrder"> Update </button>
    </modal>
  </div>
</template>

<script>
export default {
    data () {
      return {
        message: '',
        name: this.meal.name,
        price: this.meal.price,
        modalId: `updateMealButton-${this.meal.id}`
      }
    },
    props: ['meal'],
    methods: {
      toggleModal() {
        this.$root.$emit(`toggleModal-${this.modalId}`)
      },
      updateOrder() {
        this.$http.patch(`api/v1/meals/${this.meal.id}`, {meal: {name: this.name, price: this.price}}).then((response) => {
          this.$store.dispatch('updateMeal', response.data.meal )
        }).catch((error) => {
          this.$root.$emit(`displayError`, (error.response.data.message))
        })
        this.toggleModal()
      }
    }
  }
</script>
